Page MenuHomeFreeBSD

[aacraid] Add missing aac_unmap_command() call for SYNC mode
ClosedPublic

Authored by luporl on Feb 13 2020, 6:12 PM.

Details

Summary

On a PowerPC64 with an Adaptec RAID Controller with PCI device ID 0x028d, after several read/write operations, the kernel was panic'ing in bus_dmamap_sync().
This was due to a missing aac_unmap_command() in the SYNC path.

There is a work in progress (PR 237463) to make aacraid driver compatible with big-endian/PowerPC, in which this issue was found.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

luporl created this revision.Feb 13 2020, 6:12 PM
emaste added a subscriber: emaste.Mar 1 2020, 8:00 PM

Yes, the similar path in aac.c has

			aac_remove_busy(cm);
 			aac_unmap_command(cm);
luporl added a comment.Mar 2 2020, 2:20 PM

Yes, the similar path in aac.c has

			aac_remove_busy(cm);
 			aac_unmap_command(cm);

Right, but as in aacraid.c sync commands don't call aac_enqueue_busy(cm), aac_remove_busy(cm) should not be called when they complete.

jhibbits accepted this revision.Mar 3 2020, 5:47 PM
This revision is now accepted and ready to land.Mar 3 2020, 5:47 PM
This revision was automatically updated to reflect the committed changes.